Codeforces Round 952 (Div. 4) c++题解(A-H1)

2024-06-13 08:28

本文主要是介绍Codeforces Round 952 (Div. 4) c++题解(A-H1),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

开头 : 

这场没打,今天vp了一下,写了A-G,然后就去吃饭了!

比赛链接 : 

Dashboard - Codeforces Round 952 (Div. 4) - Codeforces

A

直接交换,输出即可

inline void solve(){string a , b ; cin >> a>> b ;char c = a[0] ;a[0] = b[0] ;b[0] = c ;cout << a << " " << b << endl ; 
}

B

数据范围小,模拟那个过程即可;

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;
typedef long long LL;
typedef unsigned long long ULL ;
#define PI acos(-1)
#define endl '\n'
#define pair<int,int> PII ;
#define x first
#define y second
#define no do { cout << "No" << endl; return; } while(0)
#define yes do { cout << "Yes" << endl; return; } while (0)
#define lowbit(x) ((x) & -(x))
#define rep(i, s, e) for (int i=(s);i<(e);++i)
#define all(v) v.begin(), v.end()
#define pb push_back
const LL INF = 1e18 ;
const int mod = 1e9+7;
const int N = 2e5+10;
int dx[4] = {0, 1, 0, -1}, dy[5] = {1, 0, -1, 0};LL gcd(LL a, LL b) {return b ? gcd(b, a % b) : a;
}LL qmi(int m, int k, int p){int res = 1 % p, t = m;while (k){if (k&1) res = res * t % p;t = t * t % p;k >>= 1;}return res;}inline void solve(){int n ; cin >> n ;int ans = 0 ,yss = 1 ;rep(i,2,n+1){int x = i ;int res = 0 ;while(x<=n){res += x ;x += i ;}if(res>ans) {ans = res ;yss = i ;}}cout << yss << endl ;
}signed main(){IOSint _ = 1;cin >> _;while(_ --) solve();return 0;
}

C

也是模拟遍历,先用前缀和预处理一下;

如果ma * 2 = b[i],表示a[1,i]是满足题目条件的;

inline void solve(){int n ; cin >> n ;rep(i,1,n) cin >> a[i] ;rep(i,1,n) b[i] = b[i-1] + a[i] ;int ans = 0 ;// ma // b[i]-ma = maLL ma = 0 ;rep(i,1,n){ma = max(ma,a[i]) ;if(ma*2==b[i]) ans ++ ;}cout << ans << endl; 
}

D

因为所有点都是关于中心点对称分布的,直接求横坐标,纵坐标的平均数就是答案了

inline void solve(){int n ,m ; cin >> n >> m ;vector<vector<char>> a(n+1,vector<char>(m+1)) ;vector<PII> b ;rep(i,1,n)rep(j,1,m){cin >> a[i][j] ;if(a[i][j]=='#') b.pb({i,j}) ;}int sz = b.size() ;int xx , yy ;if(sz==1){xx = b[0].x ; yy = b[0].y ;cout << xx << " " << yy << endl ;return ;}LL xs = 0 , ys = 0 ; for(auto& bc : b){int xc = bc.x , yc = bc.y ;xs += xc ;ys += yc ; }xx = xs / sz ;yy = ys / sz ;cout << xx << " " << yy << endl ; 
}

E

直接暴力即可,遍历其中两条边,复杂度(2000^2) ;

对于每个满足条件的长宽高i,j,k(也就是i*j*k==s),在S中的移动范围分别是[i,x],[j,y],[k,z];

然后相乘即可;

inline void solve(){LL x , y , z , s ; cin >> x >> y >> z >> s ;LL ans = 0 ;rpL(i,1,x){rpL(j,1,y){LL k = s / (i*j) ;if(s%(i*j)==0 && k<=z){LL res = (x-i+1)*(y-j+1)*(z-k+1) ;ans = max(ans,res) ;}}}cout << ans << endl; 
}

F

一个非常明显的二分答案,但是用堆也可以做;

(可能这场题多的原因);

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;
typedef long long LL;
typedef unsigned long long ULL ;
#define PI acos(-1)
#define endl '\n'
#define PII pair<int,int> 
#define x first
#define y second
#define no do { cout << "No" << endl; return; } while(0)
#define yes do { cout << "Yes" << endl; return; } while (0)
#define lowbit(x) ((x) & -(x))
#define rep(i, s, e) for (int i=(s);i<=(e);++i)
#define all(v) v.begin(), v.end()
#define pb push_back
const LL INF = 1e18 ;
const int mod = 1e9+7;
const int N = 2e5+10;
int dx[4] = {0, 1, 0, -1}, dy[5] = {1, 0, -1, 0};LL gcd(LL a, LL b) {return b ? gcd(b, a % b) : a;
}LL qmi(int m, int k, int p){int res = 1 % p, t = m;while (k){if (k&1) res = res * t % p;t = t * t % p;k >>= 1;}return res;}int h , n ;
int a[N] , c[N] ;bool pd(LL m){LL dmg = 0 ;rep(i,1,n){dmg += a[i] * ((m+c[i]-1) / c[i]) ;if(dmg>=h) return true ;}return dmg>=h ;
}inline void solve(){cin >> h >> n ;LL sum = 0 ;rep(i,1,n) cin >> a[i]  , sum += a[i];rep(i,1,n) cin >> c[i] ;if(sum>=h){cout << 1 << endl ;return ;}LL l = 1 , r = 2e12 ;while(l+1<r){LL m = (l+r)>>1 ;if(pd(m)) r = m ;else l = m ; // cout << l << endl ;}cout << r << endl ;
}signed main(){IOSint _ = 1;cin >> _;while(_ --) solve();return 0;
}

G

  1.      D(n) : 表示数位和;
  2. D(k*n) = k*D(n) : 那么n的所有数位上的数x在*k之后不能够进位
  3. --> 能够推出x<=[9/k]  ps : []代表下取整 
  4.  然后计算[10^l,10^r)中有多少个数n满足这个条件
  5. 对于每一个数位,有t=[9/k]+1 种选择,有r个数位,res=t^r
  6. ans = t^r-t^l

用快速幂优化一下 : 

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;
typedef long long LL;
typedef unsigned long long ULL ;
#define PI acos(-1)
#define endl '\n'
#define PII pair<int,int>
#define x first
#define y second
#define no do { cout << "No" << endl; return; } while(0)
#define yes do { cout << "Yes" << endl; return; } while (0)
#define lowbit(x) ((x) & -(x))
#define rep(i, s, e) for (int i=(s);i<=(e);++i)
#define all(v) v.begin(), v.end()
#define pb push_back
const LL INF = 1e18 ;
const int Mod = 1e9+7;
const int N = 2e5+10;
int dx[4] = {0, 1, 0, -1}, dy[5] = {1, 0, -1, 0};LL gcd(LL a, LL b) {return b ? gcd(b, a % b) : a;
}LL qmi(LL m, LL k, LL p){LL res = 1 % p, t = m;while (k){if (k&1) res = res * t % p;t = t * t % p;k >>= 1;}return res;}inline void solve(){
//	 D(n) : 表示数位和 
//	 D(k*n) = k*D(n) : 那么n的所有数位上的数x在*k之后不能够进位
//	 --> 能够推出x<=[9/k]  ps : []代表下取整 
//	 然后计算[10^l,10^r)中有多少个数n满足这个条件
//	 对于每一个数位,有t=[9/k]+1 种选择,有r个数位,res=t^r
//	  ans = t^r-t^lLL l , r , k ; cin >> l >> r >> k ;if(k>=10){cout << 0 << endl ;return ;}int p = floor(1.0*9/k)+1 ;LL ans = (qmi(p,r,Mod) - qmi(p,l,Mod)) % Mod ;if(ans<0) ans += Mod ;cout << ans << endl ;
}signed main(){IOSint _ = 1;cin >> _;while(_ --) solve();return 0;
}

H

用并查集记录关于每个点的连通块 ;

然后遍历每一行,每一列来求将这一行/列全改为#,之后的连通块的大小,找到最大的;

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;
typedef long long LL;
typedef unsigned long long ULL ;
#define PI acos(-1)
#define endl '\n'
#define PII pair<int,int> 
#define no do { cout << "No" << endl; return; } while(0)
#define yes do { cout << "Yes" << endl; return; } while (0)
#define lowbit(x) ((x) & -(x))
#define rep(i, s, e) for (int i=(s);i<=(e);++i)
#define all(v) v.begin(), v.end()
#define pb push_back
const LL INF = 1e18 ;
const int mod = 1e9+7;
const int N = 2e5+10;
int dx[4] = {0, 1, 0, -1}, dy[5] = {1, 0, -1, 0};LL gcd(LL a, LL b) {return b ? gcd(b, a % b) : a;
}LL qmi(int m, int k, int p){int res = 1 % p, t = m;while (k){if (k&1) res = res * t % p;t = t * t % p;k >>= 1;}return res;}struct DSU {std::vector<int> f, siz;DSU() {}DSU(int n) {init(n);}void init(int n) {f.resize(n);std::iota(f.begin(), f.end(), 0);siz.assign(n, 1);}int find(int x) {while (x != f[x]) {x = f[x] = f[f[x]];}return x;}bool same(int x, int y) {return find(x) == find(y);}bool merge(int x, int y) {x = find(x);y = find(y);if(x == y) return false;siz[x] += siz[y];f[y] = x;return true;}int size(int x) {return siz[find(x)];}
};inline void solve(){int n ,m ; cin >> n >> m  ;vector<string> s(n) ;rep(i,0,n-1) cin >> s[i] ;int sz = n * m ;DSU dsu(sz) ;rep(i,0,n-1){rep(j,0,m-1){if(i+1<n&&s[i][j]=='#'&&s[i+1][j]=='#'){//对行进行扩展 dsu.merge(i*m+j,(i+1)*m+j);//合并 }if(j+1<m&&s[i][j]=='#'&&s[i][j+1]=='#'){dsu.merge(i*m+j,i*m+j+1);//合并 }}}int ans = 0 ;vector<int> vis(sz,-1) ;rep(r,0,n-1){int res = 0 ;rep(i,0,m-1){//修改一行 if(s[r][i]=='.') res ++ ;//修改成#的数目 for(int xx=max(0,r-1);xx<=min(n-1,r+1);xx++){//找上下两行的联通块 if(s[xx][i]=='#'){int u=dsu.find(xx*m+i);if(vis[u]!=r){vis[u] = r ;res += dsu.size(u);}}}}ans = max(ans,res) ;}vis.assign(sz,-1) ;for(int c=0;c<m;c++){int res = 0 ;for(int i=0;i<n;i++){if(s[i][c]=='.') res++ ;for(int y=max(0,c-1);y<=min(m-1,c+1);y++){if(s[i][y]=='#'){int u = dsu.find(i*m+y);if(vis[u]!=c){vis[u] = c ;res += dsu.size(u) ;}}}}ans = max(ans,res) ;}cout << ans << endl ;
}signed main(){IOSint _ = 1;cin >> _;while(_ --) solve();return 0;
}

这篇关于Codeforces Round 952 (Div. 4) c++题解(A-H1)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1056776

相关文章

【C++ Primer Plus习题】13.4

大家好,这里是国中之林! ❥前些天发现了一个巨牛的人工智能学习网站,通俗易懂,风趣幽默,忍不住分享一下给大家。点击跳转到网站。有兴趣的可以点点进去看看← 问题: 解答: main.cpp #include <iostream>#include "port.h"int main() {Port p1;Port p2("Abc", "Bcc", 30);std::cout <<

C++包装器

包装器 在 C++ 中,“包装器”通常指的是一种设计模式或编程技巧,用于封装其他代码或对象,使其更易于使用、管理或扩展。包装器的概念在编程中非常普遍,可以用于函数、类、库等多个方面。下面是几个常见的 “包装器” 类型: 1. 函数包装器 函数包装器用于封装一个或多个函数,使其接口更统一或更便于调用。例如,std::function 是一个通用的函数包装器,它可以存储任意可调用对象(函数、函数

C++11第三弹:lambda表达式 | 新的类功能 | 模板的可变参数

🌈个人主页: 南桥几晴秋 🌈C++专栏: 南桥谈C++ 🌈C语言专栏: C语言学习系列 🌈Linux学习专栏: 南桥谈Linux 🌈数据结构学习专栏: 数据结构杂谈 🌈数据库学习专栏: 南桥谈MySQL 🌈Qt学习专栏: 南桥谈Qt 🌈菜鸡代码练习: 练习随想记录 🌈git学习: 南桥谈Git 🌈🌈🌈🌈🌈🌈🌈🌈🌈🌈🌈🌈🌈�

【C++】_list常用方法解析及模拟实现

相信自己的力量,只要对自己始终保持信心,尽自己最大努力去完成任何事,就算事情最终结果是失败了,努力了也不留遗憾。💓💓💓 目录   ✨说在前面 🍋知识点一:什么是list? •🌰1.list的定义 •🌰2.list的基本特性 •🌰3.常用接口介绍 🍋知识点二:list常用接口 •🌰1.默认成员函数 🔥构造函数(⭐) 🔥析构函数 •🌰2.list对象

06 C++Lambda表达式

lambda表达式的定义 没有显式模版形参的lambda表达式 [捕获] 前属性 (形参列表) 说明符 异常 后属性 尾随类型 约束 {函数体} 有显式模版形参的lambda表达式 [捕获] <模版形参> 模版约束 前属性 (形参列表) 说明符 异常 后属性 尾随类型 约束 {函数体} 含义 捕获:包含零个或者多个捕获符的逗号分隔列表 模板形参:用于泛型lambda提供个模板形参的名

6.1.数据结构-c/c++堆详解下篇(堆排序,TopK问题)

上篇:6.1.数据结构-c/c++模拟实现堆上篇(向下,上调整算法,建堆,增删数据)-CSDN博客 本章重点 1.使用堆来完成堆排序 2.使用堆解决TopK问题 目录 一.堆排序 1.1 思路 1.2 代码 1.3 简单测试 二.TopK问题 2.1 思路(求最小): 2.2 C语言代码(手写堆) 2.3 C++代码(使用优先级队列 priority_queue)

【C++高阶】C++类型转换全攻略:深入理解并高效应用

📝个人主页🌹:Eternity._ ⏩收录专栏⏪:C++ “ 登神长阶 ” 🤡往期回顾🤡:C++ 智能指针 🌹🌹期待您的关注 🌹🌹 ❀C++的类型转换 📒1. C语言中的类型转换📚2. C++强制类型转换⛰️static_cast🌞reinterpret_cast⭐const_cast🍁dynamic_cast 📜3. C++强制类型转换的原因📝

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

C++——stack、queue的实现及deque的介绍

目录 1.stack与queue的实现 1.1stack的实现  1.2 queue的实现 2.重温vector、list、stack、queue的介绍 2.1 STL标准库中stack和queue的底层结构  3.deque的简单介绍 3.1为什么选择deque作为stack和queue的底层默认容器  3.2 STL中对stack与queue的模拟实现 ①stack模拟实现

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m